%define anolis_release 2
# Run optional test
%bcond_without perl_Test_Warnings_enables_optional_test

Summary:	Test for warnings and the lack of them
Name:		perl-Test-Warnings
Version:	0.031
Release:	%{anolis_release}%{?dist}
License:	GPL+ or Artistic
URL:		https://metacpan.org/release/Test-Warnings
Source0:	https://cpan.metacpan.org/modules/by-module/Test/Test-Warnings-%{version}.tar.gz
BuildArch:	noarch

BuildRequires:	coreutils findutils make
BuildRequires:	perl-generators perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)

BuildRequires:	perl(Carp) perl(Exporter) perl(Test::Builder)
BuildRequires:	perl(parent) perl(strict) perl(warnings)

BuildRequires:	perl(ExtUtils::MakeMaker) perl(File::Spec)
BuildRequires:	perl(if) perl(lib) perl(Test::More) >= 0.94

%if %{with perl_Test_Warnings_enables_optional_test}

BuildRequires:	perl(CPAN::Meta) >= 2.120900 perl(CPAN::Meta::Check) >= 0.011
BuildRequires:	perl(CPAN::Meta::Prereqs) perl(CPAN::Meta::Requirements)
BuildRequires:	perl(PadWalker) perl(Test::Tester) >= 0.108
%endif

Requires:	perl(Carp)

%description
If you've ever tried to use Test::NoWarnings to confirm there are no warnings
generated by your tests, combined with the convenience of done_testing to not
have to declare a test count, you'll have discovered that these two features do
not play well together, as the test count will be calculated before the
warnings test is run, resulting in a TAP error (see examples/test_nowarnings.pl
in this distribution for a demonstration).

This module is intended to be used as a drop-in replacement for
Test::NoWarnings: it also adds an extra test, but runs this test before
done_testing calculates the test count, rather than after. It does this by
hooking into done_testing as well as via an END block. You can declare a plan,
or not, and things will still Just Work.

It is actually equivalent to:

    use Test::NoWarnings 1.04 ':early';

as warnings are still printed normally as they occur. You are safe, and
enthusiastically encouraged, to perform a global search-replace of the above
with use Test::Warnings; whether or not your tests have a plan.

%prep
%autosetup -n Test-Warnings-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
%make_build

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENCE
%doc Changes CONTRIBUTING README examples/
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::Warnings.3*

%changelog
* Thu Apr 13 2023 Kun(llfl) <llfl@linux.alibaba.com> - 0.031-2
- optimize spec file

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.031-1
- init from upstream
